REM Delete and recreate temporary backup folder. Create the first line in FileCopy.log. That line contains the version.
  rd /Q /S  C:\backup_before_upgrade
  mkdir C:\backup_before_upgrade
  Echo>C:\backup_before_upgrade\FileCopy.log Backup of old version collected via "Create Zylinc backups before upgrade V1.0.bat", available via "Zylinc Unified Help" web portal. 
  echo off
  cls
  echo You can get the latest version of "Create Zylinc backups before upgrade V1.0.bat" 
  echo via "Zylinc Unified Help" web portal. 
  echo.

  
REM Copy the part of registry that contains for example, memory settings, Java versions, and Tomcat versions
  echo Copying Tomcat registry settings...
  if exist "%programfiles%\Apache Software Foundation" regedit /E C:\backup_before_upgrade\TomcatRegistrySettings.log "HKEY_LOCAL_MACHINE\SOFTWARE\WOW6432Node\Apache Software Foundation"
  if exist "%ProgramFiles(x86)%\Apache Software Foundation" regedit /E C:\backup_before_upgrade\TomcatRegistrySettingsX86.log "HKEY_LOCAL_MACHINE\SOFTWARE\Apache Software Foundation"


REM Create a list that contains the folder names of all Tomcat instances, and store the list in %temp%\apachedirs.txt
  if exist "%programfiles%\Zylinc\ApacheInstances" dir "%programfiles%\Zylinc\ApacheInstances" /b/ad >%temp%\apachedirs.txt
  if exist "%programfiles%\Apache Software Foundation" dir "%programfiles%\Apache Software Foundation" /b/ad >>%temp%\apachedirs.txt
  if exist "%ProgramFiles(x86)%\Apache Software Foundation" dir "%ProgramFiles(x86)%\Apache Software Foundation" /b/ad >>%temp%\apachedirs.txt

  
REM Iterate through all Tomcat instance folder names in %temp%\apachedirs.txt, and copy the instance folder to a new folder in backup_before_upgrade
  for /F "tokens=*" %%A in (%temp%\apachedirs.txt) do (
    echo Copying Tomcat %%A instance folder...
    if exist "%ProgramFiles(x86)%\Apache Software Foundation\%%A" xcopy "%ProgramFiles(x86)%\Apache Software Foundation\%%A" "C:\backup_before_upgrade\Tomcat_x86_%%A" /d/s/h/c/i >>C:\backup_before_upgrade\FileCopy.log
    if exist "%programfiles%\Apache Software Foundation\%%A"      xcopy "%programfiles%\Apache Software Foundation\%%A"      "C:\backup_before_upgrade\Tomcat_x64_%%A" /d/s/h/c/i >>C:\backup_before_upgrade\FileCopy.log
    if exist "%programfiles%\Zylinc\ApacheInstances\%%A"          xcopy "%programfiles%\Zylinc\ApacheInstances\%%A"          "C:\backup_before_upgrade\Tomcat_deployment_manager_%%A" /d/s/h/c/i >>C:\backup_before_upgrade\FileCopy.log
    )
  del %temp%\apachedirs.txt

  
REM Copy additional folder locations
  echo Copying additional folder locations
  if exist "%programdata%\Zylinc" xcopy "%programdata%\Zylinc" "C:\backup_before_upgrade\ProgramData_Zylinc" /d/s/h/c/i >>C:\backup_before_upgrade\FileCopy.log 
  if exist "C:\Zylinc" xcopy "C:\Zylinc" "C:\backup_before_upgrade\C-drive_Zylinc" /d/s/h/c/i >>C:\backup_before_upgrade\FileCopy.log 
  if exist "C:\ZyCore Device" xcopy "C:\ZyCore Device" "C:\backup_before_upgrade\C-drive_ZyCore_Device" /d/s/h/c/i >>C:\backup_before_upgrade\FileCopy.log 
 
  
REM Get the path to the active user's desktop folder, and store it in %DESKTOP%
  CHCP 1251 >Nul
  for /f "usebackq tokens=1,2,*" %%B IN (`reg query "HKEY_CURRENT_USER\Software\Microsoft\Windows\CurrentVersion\Explorer\User Shell Folders" /v Desktop`) do set DESKTOP=%%D
  CHCP 866 >Nul
  for /f "delims=" %%i IN ('echo %DESKTOP%') do set DESKTOP=%%i

  
REM Zip compress the backup_before_upgrade folder to backup_before_upgrade.zip on the desktop. If PowerShell v5 is not available, just move the folder to desktop without zipping it
  echo Compressing...
  if exist %DESKTOP%\backup_before_upgrade.zip del %DESKTOP%\backup_before_upgrade.zip
  powershell Compress-Archive -Path "C:\backup_before_upgrade" -DestinationPath "%DESKTOP%\backup_before_upgrade.zip"
  if exist %DESKTOP%\backup_before_upgrade  rd /Q /S %DESKTOP%\backup_before_upgrade
  if not exist %DESKTOP%\backup_before_upgrade.zip move "C:\backup_before_upgrade" "%DESKTOP%\backup_before_upgrade"
  if exist C:\backup_before_upgrade  rd /Q /S C:\backup_before_upgrade
  cls
  echo.
  echo All relevant Zylinc folders have now been backed up and saved in
  echo backup_before_upgrade on your desktop. If PowerShell version 5 or later was available,
  echo backup_before_upgrade will be a zipped folder. If not, you can zip the folder manually.
  echo.
  pause